# wxAuiNotebook Class Reference
[Window Docking (wxAUI)]

`#include <wx/aui/auibook.h>`

Inheritance diagram for wxAuiNotebook:
[legend]

## Detailed Description

wxAuiNotebook is part of the wxAUI class framework.

See also wxAUI Overview.

wxAuiNotebook is a notebook control which implements many features common in applications with dockable panes. Specifically, wxAuiNotebook implements functionality which allows the user to rearrange tab order via drag-and-drop, split the tab window into many different splitter configurations, and toggle through different themes to customize the control's look and feel.

An effort has been made to try to maintain an API as similar to that of wxNotebook (note that wxAuiNotebook does not derive from wxNotebook!).

The default theme that is used is wxAuiDefaultTabArt, which provides a modern, glossy look and feel. The theme can be changed by calling wxAuiNotebook::SetArtProvider.

## Styles

This class supports the following styles:

- wxAUI_NB_DEFAULT_STYLE:
  Defined as wxAUI_NB_TOP | wxAUI_NB_TAB_SPLIT | wxAUI_NB_TAB_MOVE | wxAUI_NB_SCROLL_BUTTONS | wxAUI_NB_CLOSE_ON_ACTIVE_TAB.
- wxAUI_NB_TAB_SPLIT:
  Allows the tab control to be split by dragging a tab.
- wxAUI_NB_TAB_MOVE:
  Allows a tab to be moved horizontally by dragging.
- wxAUI_NB_TAB_EXTERNAL_MOVE:
  Allows a tab to be moved to another tab control.
- wxAUI_NB_TAB_FIXED_WIDTH:
  With this style, all tabs have the same width.
- wxAUI_NB_SCROLL_BUTTONS:
  With this style, left and right scroll buttons are displayed.
- wxAUI_NB_WINDOWLIST_BUTTON:
  With this style, a drop-down list of windows is available.
- wxAUI_NB_CLOSE_BUTTON:
  With this style, a close button is available on the tab bar.
- wxAUI_NB_CLOSE_ON_ACTIVE_TAB:
  With this style, the close button is visible on the active tab.
- wxAUI_NB_CLOSE_ON_ALL_TABS:
  With this style, the close button is visible on all tabs.
- wxAUI_NB_TOP:
  With this style, tabs are drawn along the top of the notebook.
- wxAUI_NB_BOTTOM:
  With this style, tabs are drawn along the bottom of the notebook.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxAuiNotebookEvent& event)
Event macros for events emitted by this class:

- EVT_AUINOTEBOOK_PAGE_CLOSE(id, func):
  Provide description.
- EVT_AUINOTEBOOK_PAGE_CHANGED(id, func):
  Provide description.
- EVT_AUINOTEBOOK_PAGE_CHANGING(id, func):
  Provide description.
- EVT_AUINOTEBOOK_BUTTON(id, func):
  Provide description.
- EVT_AUINOTEBOOK_BEGIN_DRAG(id, func):
  Provide description.
- EVT_AUINOTEBOOK_END_DRAG(id, func):
  Provide description.
- EVT_AUINOTEBOOK_DRAG_MOTION(id, func):
  Provide description.
- EVT_AUINOTEBOOK_ALLOW_DND(id, func):
  Provide description.

Todo:
  provide description for the events above.

##

Library: wxAui

Category: Window Docking (wxAUI)

## Public Member Functions
| wxAuiNotebook ()
| Default ctor.
| wxAuiNotebook (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxAUI_NB_DEFAULT_STYLE)
| Constructor.
bool | AddPage (wxWindow *page, const wxString &caption, bool select=false, const wxBitmap &bitmap=wxNullBitmap)
| Adds a page.
void | AdvanceSelection (bool forward=true)
| Sets the selection to the next or previous page.
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0)
| Creates the notebook window.
bool | DeletePage (size_t page)
| Deletes a page at the given index.
wxAuiTabArt * | GetArtProvider () const
| Returns the associated art provider.
int | GetHeightForPageHeight (int pageHeight)
| Returns the desired height of the notebook for the given page height.
wxWindow * | GetPage (size_t page_idx) const
| Returns the page specified by the given index.
wxBitmap | GetPageBitmap (size_t page) const
| Returns the tab bitmap for the page.
size_t | GetPageCount () const
| Returns the number of pages in the notebook.
int | GetPageIndex (wxWindow *page_wnd) const
| Returns the page index for the specified window.
wxString | GetPageText (size_t page) const
| Returns the tab label for the page.
int | GetSelection () const
| Returns the currently selected page.
int | GetTabCtrlHeight () const
| Returns the height of the tab control.
bool | InsertPage (size_t page_idx, wxWindow *page, const wxString &caption, bool select=false, const wxBitmap &bitmap=wxNullBitmap)
| InsertPage() is similar to AddPage, but allows the ability to specify the insert location.
bool | RemovePage (size_t page)
| Removes a page, without deleting the window pointer.
void | SetArtProvider (wxAuiTabArt *art)
| Sets the art provider to be used by the notebook.
virtual bool | SetFont (const wxFont &font)
| Sets the font for drawing the tab labels, using a bold version of the font for selected tab labels.
void | SetMeasuringFont (const wxFont &font)
| Sets the font for measuring tab labels.
void | SetNormalFont (const wxFont &font)
| Sets the font for drawing unselected tab labels.
bool | SetPageBitmap (size_t page, const wxBitmap &bitmap)
| Sets the bitmap for the page.
bool | SetPageText (size_t page, const wxString &text)
| Sets the tab label for the page.
void | SetSelectedFont (const wxFont &font)
| Sets the font for drawing selected tab labels.
size_t | SetSelection (size_t new_page)
| Sets the page selection.
virtual void | SetTabCtrlHeight (int height)
| Sets the tab height.
bool | ShowWindowMenu ()
| Shows the window menu for the active tab control associated with this notebook, and returns true if a selection was made.
virtual void | SetUniformBitmapSize (const wxSize &size)
| Split performs a split operation programmatically.
virtual void | Split (size_t page, int direction)
| Split performs a split operation programmatically.

List of all members.

## Constructor & Destructor Documentation

wxAuiNotebook::wxAuiNotebook | ( |  | ) |

Default ctor.

wxAuiNotebook::wxAuiNotebook | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxAUI_NB_DEFAULT_STYLE` |
| ) |  |  |

Constructor.

Creates a wxAuiNotebok control.

## Member Function Documentation

bool wxAuiNotebook::AddPage | ( | wxWindow * | page,
|  | const wxString & | caption,
|  | bool | select = `false`,
|  | const wxBitmap & | bitmap = `wxNullBitmap` |
| ) |  |  |

Adds a page.

If the select parameter is true, calling this will generate a page change event.

void wxAuiNotebook::AdvanceSelection | ( | bool | forward = `true` | ) |

Sets the selection to the next or previous page.

bool wxAuiNotebook::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0` |
| ) |  |  |

Creates the notebook window.

bool wxAuiNotebook::DeletePage | ( | size_t | page | ) |

Deletes a page at the given index.

Calling this method will generate a page change event.

wxAuiTabArt* wxAuiNotebook::GetArtProvider | ( |  | ) | const

Returns the associated art provider.

int wxAuiNotebook::GetHeightForPageHeight | ( | int | pageHeight | ) |

Returns the desired height of the notebook for the given page height.

Use this to fit the notebook to a given page size.

wxWindow* wxAuiNotebook::GetPage | ( | size_t | page_idx | ) | const

Returns the page specified by the given index.

wxBitmap wxAuiNotebook::GetPageBitmap | ( | size_t | page | ) | const

Returns the tab bitmap for the page.

size_t wxAuiNotebook::GetPageCount | ( |  | ) | const

Returns the number of pages in the notebook.

int wxAuiNotebook::GetPageIndex | ( | wxWindow * | page_wnd | ) | const

Returns the page index for the specified window.

If the window is not found in the notebook, wxNOT_FOUND is returned.

wxString wxAuiNotebook::GetPageText | ( | size_t | page | ) | const

Returns the tab label for the page.

int wxAuiNotebook::GetSelection | ( |  | ) | const

Returns the currently selected page.

int wxAuiNotebook::GetTabCtrlHeight | ( |  | ) | const

Returns the height of the tab control.

bool wxAuiNotebook::InsertPage | ( | size_t | page_idx,
|  | wxWindow * | page,
|  | const wxString & | caption,
|  | bool | select = `false`,
|  | const wxBitmap & | bitmap = `wxNullBitmap` |
| ) |  |  |

InsertPage() is similar to AddPage, but allows the ability to specify the insert location.

If the select parameter is true, calling this will generate a page change event.

bool wxAuiNotebook::RemovePage | ( | size_t | page | ) |

Removes a page, without deleting the window pointer.

void wxAuiNotebook::SetArtProvider | ( | wxAuiTabArt * | art | ) |

Sets the art provider to be used by the notebook.

virtual bool wxAuiNotebook::SetFont | ( | const wxFont & | font | ) | `[virtual]`

Sets the font for drawing the tab labels, using a bold version of the font for selected tab labels.

Reimplemented from wxWindow.

void wxAuiNotebook::SetMeasuringFont | ( | const wxFont & | font | ) |

Sets the font for measuring tab labels.

void wxAuiNotebook::SetNormalFont | ( | const wxFont & | font | ) |

Sets the font for drawing unselected tab labels.

bool wxAuiNotebook::SetPageBitmap | ( | size_t | page,
|  | const wxBitmap & | bitmap |
| ) |  |  |

Sets the bitmap for the page.

To remove a bitmap from the tab caption, pass wxNullBitmap.

bool wxAuiNotebook::SetPageText | ( | size_t | page,
|  | const wxString & | text |
| ) |  |  |

Sets the tab label for the page.

void wxAuiNotebook::SetSelectedFont | ( | const wxFont & | font | ) |

Sets the font for drawing selected tab labels.

size_t wxAuiNotebook::SetSelection | ( | size_t | new_page | ) |

Sets the page selection.

Calling this method will generate a page change event.

virtual void wxAuiNotebook::SetTabCtrlHeight | ( | int | height | ) | `[virtual]`

Sets the tab height.

By default, the tab control height is calculated by measuring the text height and bitmap sizes on the tab captions. Calling this method will override that calculation and set the tab control to the specified height parameter. A call to this method will override any call to SetUniformBitmapSize().

Specifying -1 as the height will return the control to its default auto-sizing behaviour.

virtual void wxAuiNotebook::SetUniformBitmapSize | ( | const wxSize & | size | ) | `[virtual]`

Split performs a split operation programmatically.

The argument page indicates the page that will be split off. This page will also become the active page after the split.

The direction argument specifies where the pane should go, it should be one of the following: wxTOP, wxBOTTOM, wxLEFT, or wxRIGHT.

bool wxAuiNotebook::ShowWindowMenu | ( |  | ) |

Shows the window menu for the active tab control associated with this notebook, and returns true if a selection was made.

virtual void wxAuiNotebook::Split | ( | size_t | page,
|  | int | direction |
| ) |  |  | `[virtual]`

Split performs a split operation programmatically.

The argument page indicates the page that will be split off. This page will also become the active page after the split.

The direction argument specifies where the pane should go, it should be one of the following: wxTOP, wxBOTTOM, wxLEFT, or wxRIGHT.

|  | [ top ]